/* Bomberflug          [Vienna 29.02.2012]
 *
 * Aufrufbeispiel fr Auslser: 
 *   temp = [position Start, 300, position TriggerPos, 700, position Endpunkt] execVM "Bomber.sqf"
 * Paramter:
 *      position Start = Logic-Objket mit Namen Start markiert die Startposition
 *                 300 = Flughhe des Bombers
 * position TriggerPos = Logic-Objket mit Namen TriggerPos markiert den Triggerplatz
 *                 700 = Triggerradius des Triggers der den Bombenabwurf auslst
 *   position Endpunkt = Logic-Objket mit Namen Endpunkt zur Lschung des Bombers
 *   
 * Es mssen nur die 3 Logic-Objekte im Editor plaziert werden.
 * Das Logic-Objekt mit Namen TriggerPos markiert das Bomberziel.
 * Der Trigger wird im Skript erstellt. Der Triggerradius ist von der Anzahl
 *  der Bomben abhngig. Einstellung der Bombenanzahl unten im Skript.                                     
*/ 

private ["_startPos", "_trgPos", "_endePos","_flugHoehe","_trgRadius","_trgBomb",
         "_clearAllWP","_addWP","_bomber","_GruppePilot","_pilot","_zeit",
         "_t","_z","_g","_s","_a","_r","_b","_v","_z"];

//Funktion alle Wegpunkgte lschen. Aufurf: <Objekt> call _clearAllWP
	_clearAllWP = compile "private['_w'];for[{_w=Count Waypoints _this},{_w>=0},{_w=_w-1}]do{deleteWaypoint[group _this,_w]}";
//Funktion Wegpunkt hinzufgen. Aufruf: [<Objekt>,[<Position>],"Type"] call _addWP
	_addWP = compile "Private['_w'];_w=group(_this select 0)AddWaypoint[_this select 1,Count Waypoints (_this select 0)];_w SetWaypointType (_this select 2);_w ShowWaypoint'always';_w";

//Parameter
_startPos  = _this select 0; //Startposition des Bombers
_flugHoehe = _this select 1; //Flughhe des Bombers
_trgPos    = _this select 2; //Position des Bombentriggers
_trgRadius = _this select 3; //Radius   des Bombentriggers
_endePos   = _this select 4; //Endposition Bomberentfernung

//Bomber erstellen
_bomber = createVehicle ["C130J", _startPos, [], 1000, "FLY"]; //Flugzeugtype
//West-Piloten erstellen
_GruppePilot = createGroup west;
_pilot = _GruppePilot createUnit ["USMC_Soldier_Pilot", [0,0], [], 0, "NONE"];
_pilot moveInDriver _bomber;
//Bomber auf Hhe setzen
_bomber setPos [getPos _bomber select 0, getPos _bomber select 1, _flugHoehe];
_bomber flyInHeight _flugHoehe;

//player moveInCargo _bomber; // <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Nur zum Testen

player groupChat "Bomber: START"; //<------------------------------Text fr Test

//Marker zeigt Bomber auf Karte
_bomber spawn
  {
    private ["_m"];
    _m=createMarker   [format["B%1",time],[0,0]];
    _m setMarkerShape "ICON";
    _m setMarkerType  "Arrow";
  	_m setMarkerColor "ColorRed";
    _m setMarkerText  "BOMBER";
    while {alive _this} do
      {
				_m setMarkerPos getPos _this;
				_m setMarkerDir getDir _this;
        sleep 0.06
      };
    deleteMarker _m    
  };

//Tigger fr den Bombenabwurf
_trgBomb=createTrigger["EmptyDetector", _trgPos];
_trgBomb setTriggerArea[_trgRadius, _trgRadius, 0, false];
_trgBomb setTriggerActivation["ANY", "PRESENT", false];
  
//Bomber Wegpunkte
[_pilot,_trgPos,  "MOVE"] call _addWP;
[_pilot,_endePos, "MOVE"] call _addWP;
//Kurs auf 1. Wegpunkt
group _pilot setCurrentWaypoint [group _pilot, 1];

//Warten bis Bomber in den Triggerbereich einfliegt
waitUntil {_bomber in list _trgBomb};

player groupChat "Bomber: Start Bombenabwurf"; //<-----------------Text fr Test

//Bomben abwerfen
_z =   30; // Anzahl der Bomben
_t =   10; // Streuung in Grad
_g =   40; // Bombengeschwindigkeit beim Abwurf
_s = -100; // Steilheit des Bombenfluges
_a =    3; // Abstand der Bombe zum Flugobjekt beim Abwurf
for "_i" from 1 to _z do
  {
    // Flugrichtung der Bombe und Streuung
    _r = (getDir _bomber) - _t + round(random _t*2); 
    // Bombe an der Position und auf Hhe (minus _a) des Flugobjektes erstellen
    _b = "bo_mk82" createVehicle [getPos _bomber select 0,getPos _bomber select 1,(getPos _bomber select 2)-_a];
    // Bombe auf Richtung setzen
    _b setDir _r; 
    // Startgeschwindigkeit und Flugsteilheit der Bombe festlegen 
    _v = velocity _b;
    _b setVelocity[(_v select 0)+(sin _r*_g),(_v select 1)+(cos _r*_g),(_v select 2) + _s];
    sleep 0.1
  };

player groupChat "Bomber: Ende Bombenabwurf"; //<------------------Text fr Test

//Kurs auf 2. Wegpunkt
group _pilot setCurrentWaypoint [group _pilot, 2];

//Bobmer und Sonstiges nach 30 Sekunden lschen
_zeit = time + 30;
waitUntil {time > _zeit};
_pilot call _clearAllWP;
deleteVehicle _bomber;
deleteVehicle _pilot;
deleteGroup   _GruppePilot;
deleteVehicle _trgBomb;

player groupChat "Bomber: Entfernt!"; //<--------------------------Text fr Test
